JUCE: MemoryOutputStream Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
MemoryOutputStream Class Reference
juce_core » streams

Writes data to an internal memory buffer, which grows as required. More...

`#include <juce_MemoryOutputStream.h>`

Inheritance diagram for MemoryOutputStream:

## Public Member Functions
| MemoryOutputStream (size_t initialSize=256)
| Creates an empty memory stream, ready to be written into.
| MemoryOutputStream (MemoryBlock &memoryBlockToWriteTo, bool appendToExistingBlockContent)
| Creates a memory stream for writing into into a pre-existing MemoryBlock object.
| MemoryOutputStream (void *destBuffer, size_t destBufferSize)
| Creates a MemoryOutputStream that will write into a user-supplied, fixed-size block of memory.
| ~MemoryOutputStream () override
| Destructor.
const void * | getData () const noexcept
| Returns a pointer to the data that has been written to the stream.
size_t | getDataSize () const noexcept
| Returns the number of bytes of data that have been written to the stream.
void | reset () noexcept
| Resets the stream, clearing any data that has been written to it so far.
void | preallocate (size_t bytesToPreallocate)
| Increases the internal storage capacity to be able to contain at least the specified amount of data without needing to be resized.
bool | appendUTF8Char (juce_wchar character)
| Appends the utf-8 bytes for a unicode character.
String | toUTF8 () const
| Returns a String created from the (UTF8) data that has been written to the stream.
String | toString () const
| Attempts to detect the encoding of the data and convert it to a string.
MemoryBlock | getMemoryBlock () const
| Returns a copy of the stream's data as a memory block.
void | flush () override
| If the stream is writing to a user-supplied MemoryBlock, this will trim any excess capacity off the block, so that its length matches the amount of actual data that has been written so far.
bool | write (const void *, size_t) override
| Writes a block of data to the stream.
int64 | getPosition () override
| Returns the stream's current position.
bool | setPosition (int64) override
| Tries to move the stream's output position.
int64 | writeFromInputStream (InputStream &, int64 maxNumBytesToWrite) override
| Reads data from an input stream and writes it to this stream.
bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat) override
| Writes a byte to the output stream a given number of times.
Public Member Functions inherited from OutputStream
virtual | ~OutputStream ()
| Destructor.
virtual void | flush ()=0
| If the stream is using a buffer, this will ensure it gets written out to the destination.
virtual bool | setPosition (int64 newPosition)=0
| Tries to move the stream's output position.
virtual int64 | getPosition ()=0
| Returns the stream's current position.
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
| Writes a block of data to the stream.
virtual bool | writeByte (char byte)
| Writes a single byte to the stream.
virtual bool | writeBool (bool boolValue)
| Writes a boolean to the stream as a single byte.
virtual bool | writeShort (short value)
| Writes a 16-bit integer to the stream in a little-endian byte order.
virtual bool | writeShortBigEndian (short value)
| Writes a 16-bit integer to the stream in a big-endian byte order.
virtual bool | writeInt (int value)
| Writes a 32-bit integer to the stream in a little-endian byte order.
virtual bool | writeIntBigEndian (int value)
| Writes a 32-bit integer to the stream in a big-endian byte order.
virtual bool | writeInt64 (int64 value)
| Writes a 64-bit integer to the stream in a little-endian byte order.
virtual bool | writeInt64BigEndian (int64 value)
| Writes a 64-bit integer to the stream in a big-endian byte order.
virtual bool | writeFloat (float value)
| Writes a 32-bit floating point value to the stream in a binary format.
virtual bool | writeFloatBigEndian (float value)
| Writes a 32-bit floating point value to the stream in a binary format.
virtual bool | writeDouble (double value)
| Writes a 64-bit floating point value to the stream in a binary format.
virtual bool | writeDoubleBigEndian (double value)
| Writes a 64-bit floating point value to the stream in a binary format.
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
| Writes a byte to the output stream a given number of times.
virtual bool | writeCompressedInt (int value)
| Writes a condensed binary encoding of a 32-bit integer.
virtual bool | writeString (const String &text)
| Stores a string in the stream in a binary format.
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
| Writes a string of text to the stream.
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
| Reads data from an input stream and writes it to this stream.
void | setNewLineString (const String &newLineString)
| Sets the string to write to the stream when a new line is written.
const String & | getNewLineString () const noexcept
| Returns the current new-line string that was set by setNewLineString().

## Additional Inherited Members
Protected Member Functions inherited from OutputStream
| OutputStream ()

## Detailed Description

Writes data to an internal memory buffer, which grows as required.

The data that was written into the stream can then be accessed later as a contiguous block of memory.

## Constructor & Destructor Documentation

## ◆ MemoryOutputStream() [1/3]

MemoryOutputStream::MemoryOutputStream | ( | size_t | initialSize = `256` | ) |

Creates an empty memory stream, ready to be written into.

Parameters

  initialSize | the initial amount of capacity to allocate for writing into

## ◆ MemoryOutputStream() [2/3]

MemoryOutputStream::MemoryOutputStream | ( | MemoryBlock & | memoryBlockToWriteTo,
|  | bool | appendToExistingBlockContent
| ) |  |

Creates a memory stream for writing into into a pre-existing MemoryBlock object.

Note that the destination block will always be larger than the amount of data that has been written to the stream, because the MemoryOutputStream keeps some spare capacity at its end. To trim the block's size down to fit the actual data, call flush(), or delete the MemoryOutputStream.

Parameters

  memoryBlockToWriteTo | the block into which new data will be written.
  appendToExistingBlockContent | if this is true, the contents of the block will be kept, and new data will be appended to it. If false, the block will be cleared before use

## ◆ MemoryOutputStream() [3/3]

MemoryOutputStream::MemoryOutputStream | ( | void * | destBuffer,
|  | size_t | destBufferSize
| ) |  |

Creates a MemoryOutputStream that will write into a user-supplied, fixed-size block of memory.

When using this mode, the stream will write directly into this memory area until it's full, at which point write operations will fail.

## ◆ ~MemoryOutputStream()

MemoryOutputStream::~MemoryOutputStream | ( |  | ) |
| override

Destructor.

This will free any data that was written to it.

## Member Function Documentation

## ◆ getData()

const void * MemoryOutputStream::getData | ( |  | ) | const
| noexcept

Returns a pointer to the data that has been written to the stream.

See also
  getDataSize

## ◆ getDataSize()

size_t MemoryOutputStream::getDataSize | ( |  | ) | const
| noexcept

Returns the number of bytes of data that have been written to the stream.

See also
  getData

## ◆ reset()

void MemoryOutputStream::reset | ( |  | ) |
| noexcept

Resets the stream, clearing any data that has been written to it so far.

## ◆ preallocate()

void MemoryOutputStream::preallocate | ( | size_t | bytesToPreallocate | ) |

Increases the internal storage capacity to be able to contain at least the specified amount of data without needing to be resized.

## ◆ appendUTF8Char()

bool MemoryOutputStream::appendUTF8Char | ( | juce_wchar | character | ) |

Appends the utf-8 bytes for a unicode character.

## ◆ toUTF8()

String MemoryOutputStream::toUTF8 | ( |  | ) | const

Returns a String created from the (UTF8) data that has been written to the stream.

## ◆ toString()

String MemoryOutputStream::toString | ( |  | ) | const

Attempts to detect the encoding of the data and convert it to a string.

See also
  String::createStringFromData

Referenced by CppTokeniserFunctions::addEscapeChars().

## ◆ getMemoryBlock()

MemoryBlock MemoryOutputStream::getMemoryBlock | ( |  | ) | const

Returns a copy of the stream's data as a memory block.

## ◆ flush()

void MemoryOutputStream::flush | ( |  | ) |
| overridevirtual

If the stream is writing to a user-supplied MemoryBlock, this will trim any excess capacity off the block, so that its length matches the amount of actual data that has been written so far.

Implements OutputStream.

## ◆ write()

bool MemoryOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| overridevirtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements OutputStream.

## ◆ getPosition()

int64 MemoryOutputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the stream's current position.

See also
  setPosition

Implements OutputStream.

## ◆ setPosition()

bool MemoryOutputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements OutputStream.

## ◆ writeFromInputStream()

int64 MemoryOutputStream::writeFromInputStream | ( | InputStream & | source,
|  | int64 | maxNumBytesToWrite
| ) |  |
| overridevirtual

Reads data from an input stream and writes it to this stream.

Parameters

  source | the stream to read from
  maxNumBytesToWrite | the number of bytes to read from the stream (if this is less than zero, it will keep reading until the input is exhausted)

Returns
  the number of bytes written

Reimplemented from OutputStream.

## ◆ writeRepeatedByte()

bool MemoryOutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat
| ) |  |
| overridevirtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented from OutputStream.

The documentation for this class was generated from the following file:

- juce_MemoryOutputStream.h